#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

Widget c_popup, diallist;
char *c_list[5];
char *buf;
int c_list_no;
extern int pipe_fd[2], pipe_fd2[2], pipe_tl1[2];

extern struct conect{
  char name[10];
  char host[30];
  int s_log;
  char incode;
  char outcode;
}list[5];

extern char *execname;

void C_select( w, client_data, call_data )
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  XawListReturnStruct  *f_ret;

  f_ret = (XawListReturnStruct *)call_data;

  c_list_no = f_ret->list_index;

}

void Conect_popdown()
{
  XtPopdown( c_popup );
}

void Conect( read_mes )
char read_mes;
{
  unsigned char *exec;
  int  exec_len;

  exec_len = strlen(execname) + strlen( list[read_mes].host );
  exec = (char*)malloc( (exec_len + 2) * sizeof(char) );
  strcpy( exec, execname );
  strcat( exec, " " );
  strcat( exec, list[read_mes].host );

  system( exec );

  free( exec );

}

void Exec_tel( w, client_data, call_data )
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  unsigned char p_flg, mes;

  mes = (char)c_list_no;

  write(pipe_fd2[1], &mes, 1);

  if( list[c_list_no].s_log == 1 )
  {
    p_flg = 0x01;
    write(pipe_fd[1], &p_flg, 1);    /* log save mode */
  }

  Conect_popdown( c_popup );
}

void Open_conect_popup(w)  /* popup text list */
Widget w;
{
  XtPopup( c_popup, XtGrabExclusive );
}

void Conect_list() /* set filename to buffer */
{
  char list_buf[35];
  int list_no;

  for( list_no = 0; list_no <= 4; list_no ++ )
  {
    sprintf( list_buf, "%d  %-10s %-20s",
         list_no+1, list[list_no].name, list[list_no].host );
    buf = (char *) calloc(strlen(list_buf) + 1, sizeof(char));
    strcpy( buf, list_buf );
    c_list[list_no] = buf;
  }

  XawListChange( diallist, c_list, 5, 0, True );

  return;
}

void Delete_cntpop( w, event, params, num_params )  /*  Delete file popup  */
Widget w;
XEvent *event;
String *params;
int    num_params;
{
  Conect_popdown();
}

void Conectpopup(parent)
Widget parent;
{
  Widget  box, done, close;
  static XtActionsRec actions[] = {{"delete", Delete_cntpop}};
  static Atom wm_delete_window;

  c_popup  = XtCreatePopupShell("popup", topLevelShellWidgetClass, parent,
			      NULL, 0);
  box    = XtCreateManagedWidget("box", boxWidgetClass, c_popup,
				    NULL, 0);
  diallist   = XtVaCreateManagedWidget("dialList", listWidgetClass, box,
				       XtNdefaultColumns, 1,
				       NULL);
  Conect_list();

  done  = XtCreateManagedWidget("done", commandWidgetClass, box,
				   NULL, 0);
  close  = XtCreateManagedWidget("close", commandWidgetClass, box,
				   NULL, 0);

  XtAddCallback(diallist, XtNcallback, C_select, NULL);
  XtAddCallback(done, XtNcallback, Exec_tel, NULL);
  XtAddCallback(close, XtNcallback, Conect_popdown, NULL);

  XtAddActions( actions, XtNumber(actions) );
  XtOverrideTranslations( c_popup,
	    XtParseTranslationTable("<Message>WM_PROTOCOLS: delete()"));
  wm_delete_window = XInternAtom(XtDisplay(c_popup), "WM_DELETE_WINDOW", False);

  XtRealizeWidget( c_popup );

  XSetWMProtocols( XtDisplay(c_popup), XtWindow(c_popup), &wm_delete_window, 1 );
}
